import { PersistenceStorageOptions } from './types';
export declare type SerializableProperty<T, P extends keyof T> = {
    key: P;
    serialize: (value: T[P]) => any;
    deserialize: (value: any) => T[P];
};
export declare const makeSerializableProperties: <T, P extends keyof T>(properties: (P | SerializableProperty<T, P>)[]) => SerializableProperty<T, P>[];
